]> git.saurik.com Git - apt.git/blob - test/integration/framework
ensure that tempfiles used for comparision are removed
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 # we all like colorful messages
4 CERROR="\e[1;31m" # red
5 CWARNING="\e[1;33m" # yellow
6 CMSG="\e[1;32m" # green
7 CINFO="\e[1;96m" # light blue
8 CDEBUG="\e[1;94m" # blue
9 CNORMAL="\e[0;39m" # default system console color
10 CDONE="\e[1;32m" # green
11 CPASS="\e[1;32m" # green
12 CFAIL="\e[1;31m" # red
13 CCMD="\e[1;35m" # pink
14
15 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} ${CNORMAL} " >&2; }
26 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30 # enable / disable Debugging
31 MSGLEVEL=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34 fi
35 if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38 fi
39 if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
46 fi
47 if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50 fi
51 if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54 fi
55 msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65 }
66
67 runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
76 }
77 aptconfig() { runapt apt-config $*; }
78 aptcache() { runapt apt-cache $*; }
79 aptget() { runapt apt-get $*; }
80 aptftparchive() { runapt apt-ftparchive $*; }
81 aptkey() { runapt apt-key $*; }
82 dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84 }
85 aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93 }
94
95 addtrap() {
96 CURRENTTRAP="$CURRENTTRAP $1"
97 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
98 }
99
100 setupenvironment() {
101 TMPWORKINGDIRECTORY=$(mktemp -d)
102 local TESTDIR=$(readlink -f $(dirname $0))
103 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
104 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
105 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
106 local OLDWORKINGDIRECTORY=$(pwd)
107 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
108 cd $TMPWORKINGDIRECTORY
109 mkdir rootdir aptarchive keys
110 cd rootdir
111 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
112 mkdir -p var/cache var/lib var/log
113 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
114 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
115 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
116 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
117 else
118 touch var/lib/dpkg/status
119 fi
120 touch var/lib/dpkg/available
121 mkdir -p usr/lib/apt
122 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
123 cd ..
124 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
125 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
126 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
127 fi
128 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
129 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
130 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
131 fi
132 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
133 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
134 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
135 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
136 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
137 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
138 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
139 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
140 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
141 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
145 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
146 export LC_ALL=C
147 msgdone "info"
148 }
149
150 configarchitecture() {
151 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
152 echo "APT::Architecture \"$1\";" > $CONFFILE
153 shift
154 while [ -n "$1" ]; do
155 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
156 shift
157 done
158 }
159
160 setupsimplenativepackage() {
161 local NAME="$1"
162 local ARCH="$2"
163 local VERSION="$3"
164 local RELEASE="${4:-unstable}"
165 local DEPENDENCIES="$5"
166 local DESCRIPTION="$6"
167 local SECTION="${7:-others}"
168 local DISTSECTION
169 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
170 DISTSECTION="main"
171 else
172 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
173 fi
174 local BUILDDIR=incoming/${NAME}-${VERSION}
175 mkdir -p ${BUILDDIR}/debian/source
176 cd ${BUILDDIR}
177 echo "* most suckless software product ever" > FEATURES
178 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
179 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
180
181 * Initial release
182
183 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
184 test -e debian/control || echo "Source: $NAME
185 Section: $SECTION
186 Priority: optional
187 Maintainer: Joe Sixpack <joe@example.org>
188 Build-Depends: debhelper (>= 7)
189 Standards-Version: 3.9.1
190
191 Package: $NAME
192 Architecture: $ARCH" > debian/control
193 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
194 if [ -z "$DESCRIPTION" ]; then
195 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
196 If you find such a package installed on your system,
197 YOU did something horribly wrong! They are autogenerated
198 und used only by testcases for APT and surf no other propose…" >> debian/control
199 else
200 echo "Description: $DESCRIPTION" >> debian/control
201 fi
202 test -e debian/compat || echo "7" > debian/compat
203 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
204 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
205 cd - > /dev/null
206 }
207
208 buildsimplenativepackage() {
209 local NAME="$1"
210 local ARCH="$2"
211 local VERSION="$3"
212 local RELEASE="${4:-unstable}"
213 local DEPENDENCIES="$5"
214 local DESCRIPTION="$6"
215 local SECTION="${7:-others}"
216 local DISTSECTION
217 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
218 DISTSECTION="main"
219 else
220 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
221 fi
222 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
223 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
224 rm -rf "incoming/${NAME}-${VERSION}"
225 }
226
227 buildpackage() {
228 local BUILDDIR=$1
229 local RELEASE=$2
230 local SECTION=$3
231 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}"
232 cd $BUILDDIR
233 if [ "$ARCH" = "all" ]; then
234 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
235 fi
236 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
237 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
238 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
239 cd - > /dev/null
240 for PKG in $PKGS; do
241 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
242 done
243 for SRC in $SRCS; do
244 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
245 done
246 msgdone "info"
247 }
248
249 buildaptarchive() {
250 if [ -d incoming ]; then
251 buildaptarchivefromincoming $*
252 else
253 buildaptarchivefromfiles $*
254 fi
255 }
256
257 createaptftparchiveconfig() {
258 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
259 if [ -z "$ARCHS" ]; then
260 # the pool is empty, so we will operate on faked packages - let us use the configured archs
261 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
262 fi
263 echo -n 'Dir {
264 ArchiveDir "' >> ftparchive.conf
265 echo -n $(readlink -f .) >> ftparchive.conf
266 echo -n '";
267 CacheDir "' >> ftparchive.conf
268 echo -n $(readlink -f ..) >> ftparchive.conf
269 echo -n '";
270 FileListDir "' >> ftparchive.conf
271 echo -n $(readlink -f pool/) >> ftparchive.conf
272 echo -n '";
273 };
274 Default {
275 Packages::Compress ". gzip bzip2 lzma";
276 Sources::Compress ". gzip bzip2 lzma";
277 Contents::Compress ". gzip bzip2 lzma";
278 };
279 TreeDefault {
280 Directory "pool/";
281 SrcDirectory "pool/";
282 };
283 APT {
284 FTPArchive {
285 Release {
286 Origin "joesixpack";
287 Label "apttestcases";
288 Suite "unstable";
289 Description "repository with dummy packages";
290 Architectures "' >> ftparchive.conf
291 echo -n "$ARCHS" >> ftparchive.conf
292 echo 'source";
293 };
294 };
295 };' >> ftparchive.conf
296 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
297 echo -n 'tree "dists/' >> ftparchive.conf
298 echo -n "$DIST" >> ftparchive.conf
299 echo -n '" {
300 Architectures "' >> ftparchive.conf
301 echo -n "$ARCHS" >> ftparchive.conf
302 echo -n 'source";
303 FileList "' >> ftparchive.conf
304 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
305 echo -n '";
306 SourceFileList "' >> ftparchive.conf
307 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
308 echo -n '";
309 Sections "' >> ftparchive.conf
310 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
311 echo '";
312 };' >> ftparchive.conf
313 done
314 }
315
316 buildaptftparchivedirectorystructure() {
317 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
318 for DIST in $DISTS; do
319 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
320 for SECTION in $SECTIONS; do
321 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
322 for ARCH in $ARCHS; do
323 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
324 done
325 mkdir -p dists/${DIST}/${SECTION}/source
326 mkdir -p dists/${DIST}/${SECTION}/i18n
327 done
328 done
329 }
330
331 insertpackage() {
332 local RELEASE="$1"
333 local NAME="$2"
334 local ARCH="$3"
335 local VERSION="$4"
336 local DEPENDENCIES="$5"
337 local ARCHS="$ARCH"
338 if [ "$ARCHS" = "all" ]; then
339 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
340 fi
341 for BUILDARCH in $ARCHS; do
342 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
343 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
344 touch aptarchive/dists/${RELEASE}/main/source/Sources
345 local FILE="${PPATH}/Packages"
346 echo "Package: $NAME
347 Priority: optional
348 Section: other
349 Installed-Size: 42
350 Maintainer: Joe Sixpack <joe@example.org>
351 Architecture: $ARCH
352 Version: $VERSION
353 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
354 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
355 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
356 If you find such a package installed on your system,
357 YOU did something horribly wrong! They are autogenerated
358 und used only by testcases for APT and surf no other propose…
359 " >> $FILE
360 done
361 }
362
363 buildaptarchivefromincoming() {
364 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
365 cd aptarchive
366 [ -e pool ] || ln -s ../incoming pool
367 [ -e ftparchive.conf ] || createaptftparchiveconfig
368 [ -e dists ] || buildaptftparchivedirectorystructure
369 msgninfo "\tGenerate Packages, Sources and Contents files… "
370 aptftparchive -qq generate ftparchive.conf
371 cd - > /dev/null
372 msgdone "info"
373 generatereleasefiles
374 }
375
376 buildaptarchivefromfiles() {
377 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
378 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
379 msgninfo "\t${line} file… "
380 cat ${line} | gzip > ${line}.gz
381 cat ${line} | bzip2 > ${line}.bz2
382 cat ${line} | lzma > ${line}.lzma
383 msgdone "info"
384 done
385 generatereleasefiles
386 }
387
388 generatereleasefiles() {
389 msgninfo "\tGenerate Release files… "
390 local DATE="${1:-now}"
391 if [ -e aptarchive/dists ]; then
392 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
393 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
394 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
395 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
396 sed -i '/^Date: / a\
397 NotAutomatic: yes' $dir/Release
398 fi
399 done
400 else
401 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
402 fi
403 if [ "$DATE" != "now" ]; then
404 for release in $(find ./aptarchive -name 'Release'); do
405 touch -d "$1" $release
406 done
407 fi
408 msgdone "info"
409 }
410
411 setupdistsaptarchive() {
412 local APTARCHIVE=$(readlink -f ./aptarchive)
413 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
414 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
415 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
416 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
417 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
418 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
419 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
420 msgdone "info"
421 done
422 }
423
424 setupflataptarchive() {
425 local APTARCHIVE=$(readlink -f ./aptarchive)
426 if [ -f ${APTARCHIVE}/Packages ]; then
427 msgninfo "\tadd deb sources.list line… "
428 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
429 msgdone "info"
430 else
431 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
432 fi
433 if [ -f ${APTARCHIVE}/Sources ]; then
434 msgninfo "\tadd deb-src sources.list line… "
435 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
436 msgdone "info"
437 else
438 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
439 fi
440 }
441
442 setupaptarchive() {
443 buildaptarchive
444 if [ -e aptarchive/dists ]; then
445 setupdistsaptarchive
446 else
447 setupflataptarchive
448 fi
449 signreleasefiles
450 msgninfo "\tSync APT's cache with the archive… "
451 aptget update -qq
452 msgdone "info"
453 }
454
455 signreleasefiles() {
456 local SIGNER="${1:-Joe Sixpack}"
457 msgninfo "\tSign archive with $SIGNER key… "
458 local SECKEYS=""
459 for KEY in $(find keys/ -name '*.sec'); do
460 SECKEYS="$SECKEYS --secret-keyring $KEY"
461 done
462 local PUBKEYS=""
463 for KEY in $(find keys/ -name '*.pub'); do
464 PUBKEYS="$PUBKEYS --keyring $KEY"
465 done
466 for RELEASE in $(find aptarchive/ -name Release); do
467 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
468 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
469 done
470 msgdone "info"
471 }
472
473 changetowebserver() {
474 if which weborf > /dev/null; then
475 weborf -xb aptarchive/ 2>&1 > /dev/null &
476 addtrap "kill $!;"
477 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
478 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
479 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
480 done
481 return 0
482 fi
483 return 1
484 }
485
486 checkdiff() {
487 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
488 if [ -n "$DIFFTEXT" ]; then
489 echo
490 echo "$DIFFTEXT"
491 return 1
492 else
493 return 0
494 fi
495 }
496
497 testfileequal() {
498 local FILE="$1"
499 shift
500 msgtest "Test for correctness of file" "$FILE"
501 if [ -z "$*" ]; then
502 echo -n "" | checkdiff $FILE - && msgpass || msgfail
503 else
504 echo "$*" | checkdiff $FILE - && msgpass || msgfail
505 fi
506 }
507
508 testequal() {
509 local COMPAREFILE=$(mktemp)
510 addtrap "rm $COMPAREFILE;"
511 echo "$1" > $COMPAREFILE
512 shift
513 msgtest "Test for equality of" "$*"
514 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
515 }
516
517 testequalor2() {
518 local COMPAREFILE1=$(mktemp)
519 local COMPAREFILE2=$(mktemp)
520 local COMPAREAGAINST=$(mktemp)
521 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
522 echo "$1" > $COMPAREFILE1
523 echo "$2" > $COMPAREFILE2
524 shift 2
525 msgtest "Test for equality OR of" "$*"
526 $* 2>&1 1> $COMPAREAGAINST
527 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
528 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
529 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
530 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
531 msgfail )
532 }
533
534 testshowvirtual() {
535 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
536 local PACKAGE="$1"
537 shift
538 while [ -n "$1" ]; do
539 VIRTUAL="${VIRTUAL}
540 N: Can't select versions from package '$1' as it purely virtual"
541 PACKAGE="${PACKAGE} $1"
542 shift
543 done
544 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
545 VIRTUAL="${VIRTUAL}
546 N: No packages found"
547 local COMPAREFILE=$(mktemp)
548 addtrap "rm $COMPAREFILE;"
549 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
550 eval `apt-config shell ARCH APT::Architecture`
551 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
552 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
553 }
554
555 testnopackage() {
556 msgtest "Test for non-existent packages" "apt-cache show $*"
557 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
558 if [ -n "$SHOWPKG" ]; then
559 echo
560 echo "$SHOWPKG"
561 msgfail
562 return 1
563 fi
564 msgpass
565 }
566
567 testdpkginstalled() {
568 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
569 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
570 if [ "$PKGS" != 0 ]; then
571 echo $PKGS
572 dpkg -l $* | grep '^[a-z]'
573 msgfail
574 return 1
575 fi
576 msgpass
577 }
578
579 testdpkgnoninstalled() {
580 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
581 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
582 if [ "$PKGS" != 0 ]; then
583 echo
584 dpkg -l $* | grep '^[a-z]'
585 msgfail
586 return 1
587 fi
588 msgpass
589 }